<template>
  <div class="container-main" ref="main">
    <div class="search-hearder" ref="topSearch">
      <el-form
        :model="queryParams"
        ref="queryForm"
        :inline="true"
        v-show="showSearch"
        label-width="auto"
      >
        <el-form-item label="部门名称" prop="depName">
          <el-input
            v-model="queryParams.depName"
            placeholder="请输入部门名称"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <!-- <el-form-item label="属地名称" prop="locationName">
          <el-input
            v-model="queryParams.locationName"
            placeholder="请输入属地名称"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item> -->
        <el-form-item label="通报类型" prop="tbType">
          <el-select
            v-model="queryParams.tbType"
            placeholder="请选择通报类型"
            clearable
            size="small"
          >
            <el-option
              v-for="dict in dict.type.tc_tb_type"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="通报时间" prop="tbTime">
          <el-date-picker
            clearable
            size="small"
            v-model="queryParams.tbTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择通报时间"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item>
          <el-button
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索</el-button
          >
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
            >重置</el-button
          >
        </el-form-item>
      </el-form>
    </div>
    <div class="layui-table-tool" ref="tableTool">
      <el-button
        type="primary"
        size="mini"
        @click="handleAdd()"
        v-hasPermi="['zongzhi:tb:add']"
        >新增</el-button
      >
      <el-button
        type="success"
        size="mini"
        :disabled="single"
        @click="handleUpdate"
        v-hasPermi="['zongzhi:tb:edit']"
        >修改</el-button
      >
      <el-button
        type="danger"
        size="mini"
        :disabled="multiple"
        @click="handleDelete"
        v-hasPermi="['zongzhi:tb:remove']"
        >删除</el-button
      >
      <el-button
        type="warning"
        size="mini"
        :loading="exportLoading"
        @click="handleExport"
        v-hasPermi="['zongzhi:tb:export']"
        >导出</el-button
      >
    </div>
    <el-table
      v-loading="loading"
      :data="tbList"
      :height="tableHeigth"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="区域" align="center" prop="areaId">
        <template slot-scope="scope">
          {{ scope.row.areaId | filterTown }}
        </template>
      </el-table-column>
      <el-table-column label="部门名称" align="center" prop="depName" />
      <!-- <el-table-column label="属地名称" align="center" prop="locationName" /> -->
      <el-table-column label="通报类型" align="center" prop="tbType">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.tc_tb_type" :value="scope.row.tbType" />
        </template>
      </el-table-column>
      <el-table-column
        label="通报时间"
        align="center"
        prop="tbTime"
        width="180"
      >
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.tbTime, "{y}-{m}-{d}") }}</span>
        </template>
      </el-table-column>
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        width="200"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            @click="handleInfo(scope.row)"
            v-hasPermi="['zongzhi:tb:list']"
          >
            查看
          </el-button>
          <el-button
            type="success"
            size="mini"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['zongzhi:tb:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="danger"
            @click="handleDelete(scope.row)"
            v-hasPermi="['zongzhi:tb:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改通报对话框 -->
    <el-dialog
      :visible.sync="open"
      width="1000px"
      append-to-body
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ title }}</div>
      <el-form
        ref="form"
        :model="form"
        :rules="rules"
        label-width="auto"
        class="dialog-from"
      >
        <el-row>
          <el-col :span="12">
            <el-form-item label="区域" prop="areaId">
              <el-cascader
                v-model="form.areaId"
                :options="townList"
                :props="treeProps"
                clearable
              ></el-cascader>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="通报类型" prop="tbType">
              <el-select v-model="form.tbType" placeholder="请选择通报类型">
                <el-option
                  v-for="dict in dict.type.tc_tb_type"
                  :key="dict.value"
                  :label="dict.label"
                  :value="parseInt(dict.value)"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="部门名称" prop="depName">
              <el-input v-model="form.depName" placeholder="请输入部门名称" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="目标IP/域名" prop="ip">
              <el-input v-model="form.ip" placeholder="请输入目标IP/域名" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="处置状态" prop="state">
              <el-select v-model="form.state" placeholder="请选择处置状态">
                <el-option
                  v-for="dict in dict.type.tc_steam_state"
                  :key="dict.value"
                  :label="dict.label"
                  :value="parseInt(dict.value)"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <!-- <el-form-item label="属地名称" prop="locationName">
              <el-input
                v-model="form.locationName"
                placeholder="请输入属地名称"
              />
            </el-form-item> -->
            <el-form-item label="通报时间" prop="tbTime">
              <el-date-picker
                clearable
                size="small"
                v-model="form.tbTime"
                type="date"
                value-format="yyyy-MM-dd"
                placeholder="选择通报时间"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12"> </el-col>
          <el-col :span="12">
            <el-form-item label="附件上传" prop="fileName">
              <FileUpload v-model="fileList" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--查看通报详情页-->
    <el-dialog
      :visible.sync="infoOpen"
      width="1000px"
      append-to-body
      :close-on-click-modal="false"
      :destroy-on-close="true"
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ infoTitle }}</div>

      <el-descriptions
        title="通报"
        :column="2"
        border
        labelClassName="desLable"
      >
        <el-descriptions-item label="区域">{{
          form.areaId
        }}</el-descriptions-item>

        <el-descriptions-item label="通报类型">
          <dict-tag :options="dict.type.tc_tb_type" :value="form.tbType" />
        </el-descriptions-item>

        <el-descriptions-item label="部门名称">{{
          form.depName
        }}</el-descriptions-item>
        <el-descriptions-item label="目标IP/域名">{{
          form.ip
        }}</el-descriptions-item>
        <el-descriptions-item label="处置状态">
          <dict-tag :options="dict.type.tc_steam_state" :value="form.state" />
        </el-descriptions-item>

        <el-descriptions-item label="属地名称">{{
          form.locationName
        }}</el-descriptions-item>

        <el-descriptions-item label="通报时间">{{
          form.tbTime
        }}</el-descriptions-item>
      </el-descriptions>
      <FileView :fileList="fileList" />
    </el-dialog>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import {
  listTb,
  getTb,
  delTb,
  addTb,
  updateTb,
  exportTb,
} from "@/api/zongzhi/netSecurity/tb/index.js";
export default {
  computed: {
    ...mapGetters(["townList", "treeProps"]),
  },
  name: "Tb",
  //注释字典
  dicts: ["tc_tb_type", "tc_steam_state"],
  data() {
    return {
      fileList: [],
      tableHeigth: 0,
      //查看详情
      infoOpen: false,
      //详情标题
      infoTitle: "",
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 通报表格数据
      tbList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        depName: null,
        locationName: null,
        tbType: null,
        tbTime: null,
        ip: null,
        state: null,
        fileName: null,
        fileUrl: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  created() {
    // //给表格一个固定值
    this.$nextTick(() => {
      this.tableHeigth =
        this.$refs.main.offsetHeight -
        (this.$refs.topSearch.offsetHeight +
          this.$refs.tableTool.offsetHeight) -
        46;
      this.getList();
    });
  },
  filters: {
    filterTown(target) {
      if (target) {
        target = JSON.parse(target);
        if (target.length > 0 && Array.isArray(target)) {
          return target.join("、");
        } else {
          return "";
        }
      }
    },
  },
  methods: {
    /** 查询通报列表 */
    getList() {
      this.loading = true;
      listTb(this.queryParams).then((response) => {
        this.tbList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,

        areaId: null,

        depName: null,

        locationName: null,

        tbType: null,

        tbTime: null,

        createId: null,

        createBy: null,

        createTime: null,

        updateId: null,

        updateBy: null,

        updateTime: null,

        remark: null,
        ip: null,
        state: null,
        fileName: null,
        fileUrl: null,
      };
      this.fileList = [];
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /**查看按钮操作 */
    handleInfo(row) {
      this.reset();
      const id = row.id || this.ids;
      getTb(id).then((response) => {
        response.data.areaId = JSON.parse(response.data.areaId);
        if (
          response.data.areaId.length > 0 &&
          Array.isArray(response.data.areaId)
        ) {
          response.data.areaId = response.data.areaId.join("、");
        } else {
          response.data.areaId = "";
        }
        this.filterFile(2, response.data.fileName, response.data.fileUrl);
        this.form = response.data;
        this.infoOpen = true;
        this.infoTitle = "查看通报详情";
      });
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加通报";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getTb(id).then((response) => {
        response.data.areaId = JSON.parse(response.data.areaId);
        this.filterFile(2, response.data.fileName, response.data.fileUrl);
        this.form = response.data;
        this.open = true;
        this.title = "修改通报";
      });
    },
    filterFile(state, fileName, fileUrl) {
      //1.提交 else 查看
      if (state == 1) {
        let fileName = [];
        let fileUrl = [];
        if (this.fileList.length > 0) {
          this.fileList.forEach((item) => {
            fileName.push(item.name);
            fileUrl.push(item.url);
          });
          this.form.fileName = fileName.join(",");
          this.form.fileUrl = fileUrl.join(",");
        } else {
          this.form.fileName = "";
          this.form.fileUrl = "";
        }
      } else {
        if (fileName || fileUrl) {
          fileName = fileName.split(",");
          fileUrl = fileUrl.split(",");
          fileName.forEach((item, index) => {
            this.fileList.push({
              name: item,
              url: fileUrl[index],
            });
          });
        } else {
          this.fileList = [];
        }
      }
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          this.form.areaId = JSON.stringify(this.form.areaId);
          this.filterFile(1);
          if (this.form.id != null) {
            updateTb(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addTb(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除通报编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delTb(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有通报数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.download(
            "/zongzhi/tb/export",
            {
              ...this.queryParams,
            },
            "通报_" + new Date().getTime() + ".xlsx"
          );
          this.exportLoading = false;
        })
        .catch(() => {});
    },
  },
};
</script>
